import {
  select,
  csv,
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  format
} from 'd3';

import {dropdownMenu} from './dropdownMenu';
import {scatterPlot} from './scatterPlot';





const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');


let data;
let xColumn;

const onXColumnClicked = column => {
     xColumn = column;
     render();
};

const render = () => {
  
  select('#menus')
	.call(dropdownMenu, {
    options: data.columns,
  	onOptionClicked: onXColumnClicked 
  });
  
  svg.call(scatterPlot, {
  	  title : 'Cars: Horsepower vs. Weight'
      xValue : d => d[xColumn];
   		xAxisLabel : 'Horsepower'; 
  	 	yValue : d => d.weight;
   		circleRadius : 10;
   		yAxisLabel : 'Weight';
     	margin : { top: 60, right: 40, bottom: 88, left: 150 };
			width,
  		height,
      data
		});

});
  
  
  
  

csv('https://vizhub.com/curran/datasets/auto-mpg.csv')
  .then(loadedData => {
    data = loadedData;
    data.forEach(d => {
      d.mpg = +d.mpg;
      d.cylinders = +d.cylinders;
      d.displacement = +d.displacement;
      d.horsepower = +d.horsepower;
      d.weight = +d.weight;
      d.acceleration = +d.acceleration;
      d.year = +d.year;  
    });
    render();
  });